#!/bin/sh

#
# 12/04/2001 - Fixed Inflex inetd line
#
#
# This routine is used as part of the inflex installation procedure
#
# Make users creates user/group required by inflex
#
#Mon Apr 23 12:01:26 EST 2001 pldaniels <pldaniels@pldaniels.com>
#	- Moved inflex.cf creation into a new script called "buildxamcf"
#	takes parameters of <sendmailcf> <inflex dir>
#
# 1.1.14 - added the full pathing for XMAdmin.conf in [x]inetd.conf
#
# 1.1.13 - Added RedHat 6x/7x option split, for things like the CRON job
#				insertion process, where 6x doesn't require a uname, where 7x
#				does
#			- Added "debugnormal" into the .conf file writer.
#
# 1.1.12 - Added "nowait.1000" to the inetd line
#
# 1.1.11 - Fixed xinetd permissions/ownership from user/group ->root.root.
#
# 1.1.10 - Added SuSE and RedHat to being OS's which require a user
#				specified in the CRON's
#
# 1.1.9 - Added NOD32 flags
#
# 1.1.8  - Added Domain-ALL's to main admin entry for xmadmin.access file
#
# 1.1.7  - Added Inflex.licence creation details.
#
# 1.1.6 	- Added question to get local domains
#			- Created/copied localdomains file
#
# 1.1.5 - Added functions to build xmadmin.access file
#
# 1.1.4 - Minor asthetic changes
#
# 1.1.3 - fixed Inflex XMADMIN services/inetd name mismatch
#
# 1.1.2 - Added SuSE support/detection
#
# 1.1.1 - Added "usesyslog" option for conf write
#
# 1.1.0 - BSD install options added.
#
# 1.0.8 - Added routines to copy/install xmapasswd
#
#



#
# Set our ANSI codes
don="\033[0;40;33m"
doff="\033[0;40;37m"
dg="\033[0;40;32m"
dw="\033[0;40;37m"
dr="\033[0;40;31m"
dbw="\033[1;40;37m"
dnw="\033[0;40;37m"
dbb="\033[1;40;34m"
dnb="\033[0;40;34m"
dbg="\033[1;40;32m"
dng="\033[0;40;32m"
bon=$don
boff=$doff


fmode=700
report=install.log
username=root
localdomain=""
sendmailpg=""
inflexdir=""
adminemail=postmaster
inflexcf=inflex.cf
grepflags=""
findflags=""
localdomainfile=localdomains
install_version="1.1.11  2001 pldaniels <pldaniels@pldaniels.com>"



#  Operating Systems
#
_redhat6x=1
_redhat7x=2
_slackware=3
_debian=4
_suse=5
_freebsd=6

#  AntiVirus software
#
_av=0
_noav=0
_fprot=1
_fprotlocation=""
_fprotflags=""
_sophos=2
_sophoslocation=""
_sophosflags=""
_mcafee=3
_mcafeelocation=""
_mcafeeflags=""
_kaspersky=4
_kasperskylocation=""
_kasperskyflags=""
_nod32=5
_nod32location=""
_nod32flags=""
_inoc=6
_inoclocation=""
_inocflags=""

#
# First, let us create some functions which we will use later on to make things easier
# First, let us create some functions which we will use later on to make things easier
# First, let us create some functions which we will use later on to make things easier


# Find SED
# Find SED
# Find SED
#
if [ -e /usr/bin/sed ]
then
	sedpg=/usr/bin/sed
	fi

if [ -e /bin/sed ]
then
	sedpg=/bin/sed
	fi

if [ -e /usr/local/bin/sed ]
then
	sedpg=/usr/local/bin/sed
	fi



# Search/Replace for the inflex.raw file
# Search/Replace for the inflex.raw file
# Search/Replace for the inflex.raw file
#
SR(){
	searchfor=${1}
	replacewith=${2}
	epath=`./escpath ${replacewith}`
	sedstring=s/$searchfor/${epath}/
	${sedpg} ${sedstring} inflex.raw > inflex.raw_
	mv inflex.raw_ inflex.raw
	}


existance=""
TEST_EXISTANCE(){
	lookfor=$1
	printf "Checking for $lookfor..."
	if [ -e $lookfor ]
	then
		printf "exists\n"
		existance=$lookfor
	else
		printf "\nCannot locate '$lookfor', please enter full path for it : "
		read x
		TEST_EXISTANCE $x
	fi
}


DETERMINE_FINDFLAGS(){

	find . -iname dontfindme > /dev/null 2>./inametest
	result=`cat ./inametest | wc -l`
	if [ $result -eq 0 ]
	then
		findflags="-iname"
	else
		findflags="-name"
	fi

	rm ./inametest > /dev/null 2>/dev/null
}


DETERMINE_GREPFLAGS(){

	is_irlallowed=`printf "testing\n" | grep -irl "testing" | wc -l`
	if [ $is_irlallowed -eq 1 ]
	then
		grepflags="-irl"
	else
		grepflags="-il"
	fi
}

DETERMINE_CRON(){

	if [ -e /etc/crontab ]
	then
		crontabfile="/etc/crontab"
	fi

	if [ -e /var/spool/cron/crontabs/root ]
	then
		crontabfile="/var/spool/cron/crontabs/root"
	fi
}


DETERMINE_CF(){

	if [ -e /etc/sendmail.cf ]
	then
		sendmailcf=/etc/sendmail.cf
	fi

	if [ -e /etc/mail/sendmail.cf ]
	then
		sendmailcf=/etc/mail/sendmail.cf
	fi
}



PRESET_OS(){
	groupadd=`which groupadd`
	useradd=`which useradd`
	ldconfig=`which ldconfig`
	libdir="/usr/lib"
	services="/etc/services"
	passwd="/etc/passwd"
	shadown="/etc/shadow"
	group="/etc/group"
	sendmailpg=`which sendmail`
	DETERMINE_GREPFLAGS
	DETERMINE_FINDFLAGS
	DETERMINE_CRON
	DETERMINE_CF
}


DETECT_OS(){

	install_os=$_slackware

	whatos=`uname -s`
	if [ $whatos = "FreeBSD" ]
	then
		install_os=$_freebsd

	elif [ -d /etc/SuSE-release ]
	then
		install_os=$_suse

	elif [ -d /usr/i386-slackware-linux ]
	then
		install_os=$_slackware

	elif [ -f /etc/redhat-release ]
	then
		ver6=`grep "6\." /etc/redhat-release | wc -l`
		ver7=`grep "7\." /etc/redhat-release | wc -l`
		if [ $ver6 -eq 1 ]
		then
			install_os=$_redhat6x
		elif [ $ver7 -eq 1 ]
		then
			install_os=$_redhat7x
		fi

	elif [ -f /etc/debian_version ]
	then
		install_os=$_debian
	fi
}



_ow_always=1
_ow_status=0

ASKOW(){

	source=$1
	owok=0

	if [ -e $inflexdir/$source ]
	then
		printf "\n%20s exists..." $source
		if [ $_ow_status -ne $_ow_always ]
		then
			printf "Overwrite [y/n/a]? "
			read x
			if [ "a$x" = "aa" ]
			then
				_ow_status=$_ow_always
				owok=1
			elif [ "a$x" = "ay" ]
			then
				owok=1
			fi
		else
			owok=1
			printf "   [$don overwriting $doff]"
		fi
	else
		printf "\n%40s installing..." $source
		owok=1
	fi

	if [ $owok -eq 1 ]
	then
		cp $source $inflexdir
		chmod $fmode $inflexdir/$source
		chown $username $inflexdir/$source
	fi

}




DETECT_AV(){

	_av=$_noav

	if [ -e /usr/local/nod32/nod32 ]
	then
		_av=$_nod32
	fi

	if [ -e /usr/local/fsav/fsav ]
	then
		_av=$_fprot
	fi

	if [ -e /usr/local/avp/avp ]
	then
		_av=$_kaspersky
	fi

	if [ -e /usr/local/bin/sweep ]
	then
		_av=$_sophos
	fi

	# Corrected from mcafee/uvscan to uvscan/uvscan - Deryk Robosson 01/08/2001
	if [ -e /usr/local/uvscan/uvscan ]
	then
		_av=$_mcafee
	fi
}


SETAVDETAILS(){

if [ $_av -eq $_fprot ]
then
	_fprotlocation="/usr/local/fsav/fsav"
	_fprotflags=" --archive --list --dumb --auto"
fi

if [ $_av -eq $_sophos ]
then
	_sophoslocation="/usr/local/bin/sweep"
	_sophosflags=" -archive -all -rec -sc -dn"
fi

if [ $_av -eq $_mcafee ]
then
	_mcafeelocation="/usr/local/uvscan/uvscan"
	_mcafeeflags=" --secure -rv --summary"
fi

if [ $_av -eq $_kaspersky ]
then
	_kasperskylocation="/usr/local/avp/avp"
	_kasperskyflags=" -Y"
fi

if [ $_av -eq $_nod32 ]
then
	_nod32location="/usr/local/nod32/nod32"
	_nod32flags="-s+ -heursafe"
fi

if [ $_av -eq $_inoc ]
then
	_inoclocation="/usr/local/inoculateit/inocucmd"
	_inocflags="-sec -nex "
fi

}


DISPLAY_DETAILS(){

printf "\
\n\
Install path    : $dg$inflexdir$doff\n\
Admin Email     : $dg$adminemail$doff\n\
\n\
Local Domain    : $dg$localdomain$doff\n\
Sendmail        : $dg$sendmailpg$doff\n\
Sendmail.cf file: $dg$sendmailcf$doff\n\
crontab file    : $dg$crontabfile$doff\n\
\n\
find flags      : $dg$findflags$doff\n\
grep flags      : $dg$grepflags$doff\n\
\n\
   ANTI-Virus details\n"

if [ "a$_fprotlocation" != "a" ]
then
	printf "\
FPROT           :	$dg$_fprotlocation$doff\n\
FLAGS           : $dg$_fprotflags$doff\n"
fi

if [ "a$_sophoslocation" != "a" ]
then
	printf "\
Sophos          :	$dg$_sophoslocation$doff\n\
Flags           : $dg$_sophosflags$doff\n"
fi

if [ "a$_mcafeelocation" != "a" ]
then
	printf "\
Mcafee          : $dg$_mcafeelocation$doff\n\
Flags           : $dg$_mcafeeflags$doff\n"
fi

if [ "a$_kasperskylocation" != "a" ]
then
	printf "\
Kaspersky       : $dg$_kasperskylocation$doff\n\
Flags           : $dg$_kasperskyflags$doff\n"
fi

if [ "a$_nod32location" != "a" ]
then
	printf "\
NOD32           : $dg$_nod32location$doff\n\
Flags           : $dg$_nod32flags$doff\n"
fi

if [ "a$_inoclocation" != "a" ]
then
	printf "\
Innoculate      : $dg$_inoclocation$doff\n\
Flags           : $dg$_inocflags$doff\n"
fi

}





	#
	#
	# COMPILE fixcf, alterMIME and ripMIME
	# COMPILE fixcf, alterMIME and ripMIME
	# COMPILE fixcf, alterMIME and ripMIME
	#
	#



# First off, compile fixcf
# First off, compile fixcf
# First off, compile fixcf
#
printf "Compiling FixCF...\n"
make fixcf
printf "${don}done.${doff}\n"




# Then make and install ripMIME
# Then make and install ripMIME
# Then make and install ripMIME
#
printf "\n\n\Compiling and installing ripMIME...(http://pldaniels.com/ripmime)\n"
cd ripmime-1.2.5
make
strip ripmime
# make install -- removed in 1.0.9, it's not nice to just clobber existing installs
cp ./ripmime ..
cd ..
printf "${don}done.${doff}\n"

# Then make alterMIME
# Then make alterMIME
# Then make alterMIME
#
printf "\n\n\Compiling alterMIME...(http://pldaniels.com/altermime)\n"
cd altermime-0.1.10
make
strip altermime
cp ./altermime ..
cd ..
printf "${don}done.${doff}\n"






# START THE USER-INTERACTIVE-INSTALL-----------------------------
# START THE USER-INTERACTIVE-INSTALL-----------------------------
# START THE USER-INTERACTIVE-INSTALL-----------------------------
#
#

	# Save our inflex.raw to a safe place...
	cp inflex.raw inflex.raw.safe

clear
printf  "$doff\nInstall version : $install_version\n\n\n\n\
                 Welcome to Inflex\n\
					  \n\n\n\n\n\n\n\n\n\n\n\n\
					  \n"


printf "Press ENTER/RETURN to commence..."
read x
clear

# clear our log file
echo "" > $report


printf "Determining your Operating system / Distribution..."
DETECT_OS
printf "$don done $doff\n"

printf "Determining various binary and file locations..."
PRESET_OS
printf "$don done $doff\n"

printf "Determining which AntiVirus agent you have (if any)..."
DETECT_AV
printf "$don done $doff\n"

printf "Setting up AntiVirus parameters..."
SETAVDETAILS
printf "$don done $doff\n"


localdomain=localhost
printf "What is the primary email domain (ie pldaniels.com) : "
read x
if [ "a$x" != "a" ]
then
	localdomain=$x
	fi


inflexdir=/usr/local/inflex
printf  "Where would you like inflex installed? [$don${inflexdir}$doff] : "
read x
if [ "a$x" != "a" ]
then
	inflexdir=$x
	fi


printf  "When Emails are blocked, who should receive notification? [$don${adminemail}$doff] : "
read x
if [ "a$x" != "a" ]
then
	adminemail=$x
	fi


printf "Would you like to use a disclaimer [$inflexdir/disclaimer] (y/n) : "
read x
if [ "a$x" != "an" ]
then
	usedisclaimer="y"
else
	usedisclaimer="n"
fi

clear

printf "\n\n\n\nDetails of your installation...\n"
DISPLAY_DETAILS
printf "Do you wish to install? (y/n) : "
read x
if [ "a$x" != "ay" ]
then
	printf  "\n\
	You can reinstall simply by typing in ./install.sh again.\n\n\n"
	cp inflex.raw.safe inflex.raw
	exit
fi

clear

printf "${dg}Creating 'inflex' script...${doff}\n"
# Create our local domain file....
#
printf "$localdomain\n" >> $localdomainfile


# Get our system specific binary locations, and insert them into the inflex.raw file
# Get our system specific binary locations, and insert them into the inflex.raw file
# Get our system specific binary locations, and insert them into the inflex.raw file
#
SR __INFLEXDIR__ $inflexdir
SR __ADMIN_EMAIL__ $adminemail
SR __LOCALDOMAIN__ $localdomain
SR __USEDISCLAIMER__ $usedisclaimer
SR __DISCLAIMER__ $disclaimer
SR __CUT__ `which cut`
SR __TEST__ `which test`
SR __GREP__ `which grep`
SR __FILE__ `which file`
SR __FIND__ `which find`
SR __TOUCH__ `which touch`
SR __SENDMAIL__ $sendmailpg
SR __SENDMAIL_CF__ $sendmailcf
SR __RIPMIME__ "./ripmime"
SR __ALTERMIME__ "./altermime"
SR __GREP_FLAGS__ $grepflags
SR __FIND_FLAGS__ $findflags

SR __FSAV__ $_fprotlocation
SR __FSAVFLAGS__ ${_fprotflags}
SR __SOPHOS__ $_sophoslocation
SR __SOPHOSFLAGS__ ${_sophosflags}
SR __MCAFEE__ $_mcafeelocation
SR __MCAFEEFLAGS__ ${_mcafeeflags}
SR __NOD32__ $_nod32location
SR __NOD32FLAGS__ ${_nod32flags}
SR __INOC__ $_inoclocation
SR __INOCFLAGS__ ${_inocflags}
SR __KASPERSKY__ $_kasperskylocation
SR __KASPERSKYFLAGS__ ${_kasperskyflags}

cp inflex.raw inflex

# Create our inflex.cf file off the existing sendmail.cf
# Create our inflex.cf file off the existing sendmail.cf
# Create our inflex.cf file off the existing sendmail.cf
#
printf "${dg}Creating MDA file...${doff}"
printf "\n\
Minflex,	P=${inflexdir}/inflex, F=ClsDFM:/|@qShPm,\n\
		S=0, R=0, T=DNS/RFC822/X-Unix,\n\
		A=inflex \$h \$u \$f \n" > ./Minflex.MDA
printf "$don done.$doff\n"




# Then apply it to the current sendmail.cf file...
# Then apply it to the current sendmail.cf file...
# Then apply it to the current sendmail.cf file...
#
printf "${dg}Applying updates to sendmail.cf to create inflex.cf...${doff}"
./fixcf -s ${inflexdir}/spool -t ${inflexdir}/inflex.st -m ./Minflex.MDA -i ${sendmailcf} -o ./inflex.cf > /dev/null 2>/dev/null
printf "$don done.$doff\n"



# Create the directories...
# Create the directories...
# Create the directories...
#
printf "${dg}Creating directories...${doff}\n"
mkdir -p ${inflexdir} >>$report 2>>$report
mkdir -p ${inflexdir}/spool  >>$report 2>>$report
mkdir -p ${inflexdir}/tmp >>$report 2>>$report



# Install our binaries
# Install our binaries
# Install our binaries
#
printf "${dg}Installing binary files...${doff}\n"
fmode=700
for source in inflex inflex.cf ripmime altermime; do
	ASKOW $source
done;

mv inflex.raw.safe inflex.raw

# Create a small disclaimer file...
if [ -e $inflexdir/disclaimer ]
then
	printf "\n\n${dg}Disclaimer already exists...not overwriting${doff}\n"
else
	printf "\n______________________________________\n\
Scanned and protected by Inflex\n\
http://pldaniels.com/inflex\n" > $inflexdir/disclaimer
fi

# Set root.root ability of the inflex file
# Set root.root ability of the inflex file
# Set root.root ability of the inflex file
#
chmod a+s ${inflexdir}/inflex >>$report 2>>$report

# Install the script files...
# Install the script files...
# Install the script files...
#
#printf "\n\n$dg Installing Blocked-Email report generators... $doff"
#fmode=750
#for source in mailadmin mailreceiver mailsender;
#do
#	ASKOW $source
#done


# Lets try get our CRON entries in...
# Lets try get our CRON entries in...
# Lets try get our CRON entries in...
#
printf "\n\n$dg Searching for CRONTAB entries for Sendmail queuing...$doff\n"

# now lets do the sendmail -q
#
#
cronexists=`grep "sendmail -q" $crontabfile | grep -v grep | wc -l`
if [ $cronexists -eq 0 ]
then
	if [ $install_os -eq $_freebsd\
		 -o $install_os -eq $_suse\
		 -o $install_os -eq $_redhat7x ]
	then
		printf "0,15,30,45	*	*	*	*	root	$sendmailpg -q\n" >> $crontabfile
	else
		printf "0,15,30,45 * * * *	${sendmailpg} -q\n" >> $crontabfile
	fi
	printf "Sendmail queue entry...$don done.$doff\n"
else
	printf "Sendmail queue entry...already exists, $don skipping update$doff\n"
fi




printf  "\n\
Do you want to restart sendmail (y/n) : "
read x
clear
if [ "a$x" != "an" ]
then
	printf "$dg Killing existing sendmail services...$doff"
	killall sendmail
	sleep 2
	printf "$don done.$doff\n$dg Restarting sendmail...$doff"

	${sendmailpg} -bd -q15m -C $inflexdir/$inflexcf
	sleep 2
	count=`ps -ax | grep sendmail | grep -v grep | wc -l`
	if [ $count -gt 0 ]
	then
		printf  "$don Successfully restarted$doff.\n"
	else
		printf  "$dr Error - Could not restart$doff.\n"
		fi
	fi


printf "\n__________________________________________________________________\n"
printf  "\nCongratulations, Inflex is installed.\n\n\
\n\
\n\
Thankyou and enjoy the new safety of your email...\n\n\
$install_version\n"

printf "\n__________________________________________________________________\n\n\n"

#----------------------------------------DONE.
